<%@ page contentType="text/html; charset=utf-8"%>
<%@ page import="java.util.Date" %>
<%@ page import="java.util.Map" %>
<%@ page import="java.util.HashMap" %>
<%@ page import="java.util.Iterator" %>
<%@ page import="java.io.PrintWriter" %>
<%@ page import="java.io.BufferedReader" %>
<%@ page import="java.io.InputStreamReader" %>
<%@ page import="java.net.URL" %>
<%@ page import="java.net.URLEncoder" %>
<%@ page import="java.net.HttpURLConnection" %>
<%@ page import="java.text.SimpleDateFormat" %>
<%@ page import="java.security.MessageDigest" %>
<%@ page import="org.json.simple.JSONObject" %>
<%@ page import="org.json.simple.parser.JSONParser" %>
<%@ page import="org.apache.commons.codec.binary.Hex" %>
<%@ page import="java.util.StringTokenizer" %>
<%@ page import="javax.crypto.Cipher" %>
<%@ page import="javax.crypto.spec.SecretKeySpec" %>
<%
request.setCharacterEncoding("utf-8"); 
/*
****************************************************************************************
* <인증 결과 파라미터>
****************************************************************************************
*/
String payMethod 	= (String)request.getParameter("payMethod"); 	// 결제수단
String mid 			= (String)request.getParameter("mid"); 			// 상점 아이디
//String cpCd			= (String)request.getParameter("cpCd");			// 
//String cardTypeCd	= (String)request.getParameter("cardTypeCd");	// 
String cardNo		= (String)request.getParameter("cardNo");		// 
String expireYymm	= (String)request.getParameter("expireYymm");	// 
String ordAuthNo	= (String)request.getParameter("ordAuthNo");	// 
String cardPw		= (String)request.getParameter("cardPw");		// 
String quotaMon		= (String)request.getParameter("quotaMon");		// 

String goodsNm		= (String)request.getParameter("goodsNm");		// 
String ordNo 		= (String)request.getParameter("ordNo"); 		// 상점 주문번호
String goodsAmt 	= (String)request.getParameter("goodsAmt"); 	// 결제 금액
String ordNm		= (String)request.getParameter("ordNm");		// 
String ordTel		= (String)request.getParameter("ordTel");		// 
String ordEmail		= (String)request.getParameter("ordEmail");		// 
String notiUrl		= (String)request.getParameter("notiUrl");		// 
String userIp		= (String)request.getParameter("userIp");		// 
String trxCd		= (String)request.getParameter("trxCd");		// 
String mbsReserved	= (String)request.getParameter("mbsReserved");	// 
String charSet		= (String)request.getParameter("charSet");		// 
String noIntFlg		= "0";											// 
String pointFlg		= "0";											// 

String merchantKey 	= "발급받은 상점 Key";								// 상점키

	/*
	*******************************************************
	* <해쉬암호화> (수정하지 마세요)
	* SHA-256 해쉬암호화는 거래 위변조를 막기위한 방법입니다. 
	*******************************************************
	*/
	DataEncrypt sha256Enc 	= new DataEncrypt();
	String ediDate 			= getyyyyMMddHHmmss();												// 전문 생성일시
	String encData	 		= sha256Enc.encrypt(mid + ediDate + goodsAmt + merchantKey);	// Hash 값

	/*
	****************************************************************************************
	* <승인 요청 >
	****************************************************************************************
	*/
	StringBuffer requestData = new StringBuffer();
	requestData.append("payMethod=").append(payMethod).append("&");
	requestData.append("mid=").append(mid).append("&");
	requestData.append("ediDate=").append(ediDate).append("&");
	//requestData.append("cpCd=").append(cpCd).append("&");
	//requestData.append("cardTypeCd=").append(cardTypeCd).append("&");
	requestData.append("cardNo=").append(cardNo).append("&");
	requestData.append("expireYymm=").append(expireYymm).append("&");
	requestData.append("ordAuthNo=").append(ordAuthNo).append("&");
	requestData.append("cardPw=").append(cardPw).append("&");
	requestData.append("quotaMon=").append(quotaMon).append("&");
	requestData.append("goodsNm=").append(goodsNm).append("&");
	requestData.append("ordNo=").append(ordNo).append("&");
	requestData.append("goodsAmt=").append(goodsAmt).append("&");
	requestData.append("ordNm=").append(ordNm).append("&");
	requestData.append("ordTel=").append(ordTel).append("&");
	requestData.append("ordEmail=").append(ordEmail).append("&");
	requestData.append("notiUrl=").append(notiUrl).append("&");
	requestData.append("userIp=").append(userIp).append("&");
	requestData.append("trxCd=").append(trxCd).append("&");
	requestData.append("mbsReserved=").append(mbsReserved).append("&");
	requestData.append("noIntFlg=").append(noIntFlg).append("&");
	requestData.append("pointFlg=").append(pointFlg).append("&");
	requestData.append("charSet=").append("utf-8").append("&");	
	requestData.append("encData=").append(encData);
		
	String reveiceData = connectToServer(requestData.toString(), "https://api.wayup.co.kr/pay.keyin");
	Map<String, Object> resultData = jsonStringToHashMap(reveiceData);
	
	/*
	****************************************************************************************
	* <결제 결과 파라미터>
	****************************************************************************************
	*/
	String sResultCode	 	= (String)resultData.get("resultCd"); 	// 결과코드
	String sResultMsg 		= (String)resultData.get("resultMsg"); 	// 결과메시지
	String sPayMethod 		= (String)resultData.get("payMethod"); 	// 결제수단
	String sAmt 			= (String)resultData.get("amt"); 		// 결제금액
	String sTid 			= (String)resultData.get("tid"); 		// 거래ID
	String sName			= (String)resultData.get("ordNm");		// 고객명
	String sGoodsName		= (String)resultData.get("goodsName");	// 상품명
	String sCardCd			= (String)resultData.get("appCardCd");	// 카드사코드
	String sQuota			= (String)resultData.get("quota");		// 할부개월
	if("0".equals(sQuota) || "00".equals(sQuota)){
		sQuota = "일시불";
	}else{
		sQuota = sQuota + "개월";
	}

%>
<!DOCTYPE html>
<html>
<head>
<meta charset="utf-8">
<meta http-equiv="Cache-Control" content="no-cache" />
<meta name="viewport" content="width=device-width, height=device-height, initial-scale=1.0, minimum-scale=1.0, maximum-scale=3.0">
<title>PAY RESULT</title>
<style>
.pop_wrap {background:rgba(0, 0, 0, 0.4);}
.tbl_th{box-sizing:border-box; line-height:40px; padding:0px 10px 0px 10px; text-align:left; width:160px; background:#e9eaeb; border-top:1px solid #2a323c; border-bottom:1px solid #d4d6d8; font-size:15px; font-weight:normal; color:#333; font-family:'Malgun Gothic','맑은 고딕',sans-serif;}
.tbl_td{box-sizing:border-box; line-height:40px; padding:0px 10px 0px 10px; text-align:left; border-top:1px solid #2a323c; border-bottom:1px solid #d4d6d8; font-size:15px; font-weight:bold; color:#333; font-family:'Malgun Gothic','맑은 고딕',sans-serif;}
</style>
</head>
<body>
<div style="width: 100%; text-align: center;">
    <div id="sampleInput" style="display: inline-block; padding:0 10px; margin:0 auto;">
        <table style="border-spacing:0;">
            <tbody>
                <tr>
                    <td colspan="3"><p style="margin:10px 0 10px; text-align:center; font-size:34px; color:#2a323c; font-family:'Malgun Gothic','맑은 고딕',sans-serif;">결제 결과</p></td>
                </tr>                		
                <tr>
                    <td colspan="3">
                        <table style="border-collapse:collapse; width:100%">
                            <tbody>
                                <tr>
                                    <th scope="row" class="tbl_th">결과 내용</th>
                                </tr>
                                <tr>
                                    <td class="tbl_td">[<%=sResultCode%>]<%=sResultMsg%></td>
                                </tr>                              
                                <tr>
                                    <th scope="row" class="tbl_th">결제수단</th>
                                </tr>
                                <tr>
                                    <td class="tbl_td"><%=sPayMethod%></td>
                                </tr>
                                <tr>
                                    <th scope="row" class="tbl_th">금액</th>
                                 </tr>
                                <tr>
                                    <td class="tbl_td"><%=sAmt%></td>
                                </tr>
                                <tr>
                                    <th scope="row" class="tbl_th">거래아이디</th>
                                 </tr>
                                <tr>
                                    <td class="tbl_td"><%=sTid%></td>
                                </tr>
                                <tr>
                                    <th scope="row" class="tbl_th">구매자명</th>
                                 </tr>
                                <tr>
                                    <td class="tbl_td"><%=sName%>&nbsp;</td>
                                </tr>
                                <tr>
									<th scope="row" class="tbl_th">상품명</th>
							      </tr>
                                <tr>
									<td class="tbl_td"><%=sGoodsName%></td>
								</tr>
								<tr>
									<th scope="row" class="tbl_th">카드사코드</th>
								 </tr>
                                <tr>
									<td class="tbl_td"><%=sCardCd%></td>
								</tr>
								<tr>
									<th scope="row" class="tbl_th">할부개월</th>
									 </tr>
                                <tr>
									<td class="tbl_td"><%=sQuota%></td>
								</tr>
                            </tbody>
                        </table>
                    </td>
                </tr>
            </tbody>
        </table>
    </div>
</div>
</body>
</html>
<%!

public final synchronized String getyyyyMMddHHmmss(){
	SimpleDateFormat yyyyMMddHHmmss = new SimpleDateFormat("yyyyMMddHHmmss");
	return yyyyMMddHHmmss.format(new Date());
}
// SHA-256 형식으로 암호화
public class DataEncrypt{
	MessageDigest md;
	String strSRCData = "";
	String strENCData = "";
	String strOUTData = "";
	
	public DataEncrypt(){ }
	public String encrypt(String strData){
		String passACL = null;
		MessageDigest md = null;
		try{
			md = MessageDigest.getInstance("SHA-256");
			md.reset();
			md.update(strData.getBytes());
			byte[] raw = md.digest();
			passACL = encodeHex(raw);
		}catch(Exception e){
			System.out.print("암호화 에러" + e.toString());
		}
		return passACL;
	}
	
	public String encodeHex(byte [] b){
		char [] c = Hex.encodeHex(b);
		return new String(c);
	}
}

	//server to server 통신
	public String connectToServer(String data, String reqUrl) throws Exception{
		HttpURLConnection conn 		= null;
		BufferedReader resultReader = null;
		PrintWriter pw 				= null;
		URL url 					= null;
		
		int statusCode = 0;
		StringBuffer recvBuffer = new StringBuffer();
		try{
			url = new URL(reqUrl);
			conn = (HttpURLConnection) url.openConnection();
			conn.setRequestMethod("POST");
			conn.setConnectTimeout(15000);
			conn.setReadTimeout(25000);
			conn.setDoOutput(true);
			
			pw = new PrintWriter(conn.getOutputStream());
			pw.write(data);
			pw.flush();
			
			statusCode = conn.getResponseCode();
			resultReader = new BufferedReader(new InputStreamReader(conn.getInputStream(), "utf-8"));
			for(String temp; (temp = resultReader.readLine()) != null;){
				recvBuffer.append(temp).append("\n");
			}
			
			if(!(statusCode == HttpURLConnection.HTTP_OK)){
				throw new Exception();
			}
			
			return recvBuffer.toString().trim();
		}catch (Exception e){
			return "9999";
		}finally{
			recvBuffer.setLength(0);
			
			try{
				if(resultReader != null){
					resultReader.close();
				}
			}catch(Exception ex){
				resultReader = null;
			}
			
			try{
				if(pw != null) {
					pw.close();
				}
			}catch(Exception ex){
				pw = null;
			}
			
			try{
				if(conn != null) {
					conn.disconnect();
				}
			}catch(Exception ex){
				conn = null;
			}
		}
	}
	//JSON String -> HashMap 변환
	private static HashMap jsonStringToHashMap(String str) throws Exception{
		HashMap dataMap = new HashMap();
		JSONParser parser = new JSONParser();
		try{
			Object obj = parser.parse(str);
			JSONObject jsonObject = (JSONObject)obj;
			
			Iterator<String> keyStr = jsonObject.keySet().iterator();
			while(keyStr.hasNext()){
				String key = keyStr.next();
				Object value = jsonObject.get(key);
				
				dataMap.put(key, value);
			}
		}catch(Exception e){
			
		}
		return dataMap;
	}
%>