<?php
header("Content-Type:text/html; charset=utf-8;"); 
/*
****************************************************************************************
* <인증 결과 파라미터>
****************************************************************************************
*/
$payMethod			=	$_POST['payMethod'];		// 결제수단
$mid				=	$_POST['mid'];				// 상점 아이디
$cpCd				=	$_POST['cpCd'];				// 
$cardTypeCd			=	$_POST['cardTypeCd'];		// 
$cardNo				=	$_POST['cardNo'];			// 
$expireYymm			=	$_POST['expireYymm'];		// 
$ordAuthNo			=	$_POST['ordAuthNo'];		// 
$cardPw				=	$_POST['cardPw'];			// 
$quotaMon			=	$_POST['quotaMon'];			// 

$goodsNm			=	$_POST['goodsNm'];			// 
$ordNo				=	$_POST['ordNo'];			// 싱잠 주문번호
$goodsAmt			=	$_POST['goodsAmt'];			// 결제 금액
$ordNm				=	$_POST['ordNm'];			// 
$ordTel				=	$_POST['ordTel'];			// 
$ordEmail			=	$_POST['ordEmail'];			// 
$notiUrl			=	$_POST['notiUrl'];			// 
$userIp				=	$_POST['userIp'];			// 
$trxCd				=	$_POST['trxCd'];			// 
$mbsReserved		=	$_POST['mbsReserved'];		// 상점 예약필드
$charSet			=	$_POST['charSet'];			// 
$noIntFlg			=	'0';						// 
$pointFlg			=	'0';						// 

$merchantKey		=	'발급받은 상점 Key';				// 상점키

/*
*******************************************************
* <해쉬암호화> (수정하지 마세요)
* SHA-256 해쉬암호화는 거래 위변조를 막기위한 방법입니다. 
*******************************************************
*/ 
$ediDate = date("YmdHis");
$encData = bin2hex(hash('sha256', $mid.$ediDate.$goodsAmt.$merchantKey, true));

/*
****************************************************************************************
* <승인 결과 파라미터 정의>
* 샘플페이지에서는 승인 결과 파라미터 중 일부만 예시되어 있으며, 
* 추가적으로 사용하실 파라미터는 연동메뉴얼을 참고하세요.
****************************************************************************************
*/

	/*
	****************************************************************************************
	* <승인 요청 >
	****************************************************************************************
	*/
	try{
		$data = Array(
			'payMethod' => $payMethod,
			'mid' => $mid,
			'ediDate' => $ediDate,
			'cpCd' => $cpCd,
			'cardTypeCd' => $cardTypeCd,
			'cardNo' => $cardNo,
			'expireYymm' => $expireYymm,
			'ordAuthNo' => $ordAuthNo,
			'cardPw' => $cardPw,
			'quotaMon' => $quotaMon,
			'goodsNm' => $goodsNm,
			'ordNo' => $ordNo,
			'goodsAmt' => $goodsAmt,
			'ordNm' => $ordNm,
			'ordTel' => $ordTel,
			'ordEmail' => $ordEmail,
			'notiUrl' => $notiUrl,
			'userIp' => $userIp,
			'trxCd' => $trxCd,
			'mbsReserved' => $mbsReserved,
			'noIntFlg' => $noIntFlg,
			'pointFlg' => $pointFlg,
			'charSet' => 'utf-8',
			'encData' => $encData
		);
		$response = reqPost($data, "https://api.wayup.co.kr/pay.keyin");
		jsonRespDump($response);
		
	} catch(Exception $e){
		// 실패처리
	}

// API CALL foreach 예시
function jsonRespDump($resp){
	$respArr = json_decode($resp);
	foreach ( $respArr as $key => $value ){
		echo "$key=". $value."<br />";
	}
}

//Post api call
function reqPost(Array $data, $url){
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, $url);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 15);					//connection timeout 15 
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
	curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($data));	//POST data
	curl_setopt($ch, CURLOPT_POST, true);
	$response = curl_exec($ch);
	curl_close($ch);	 
	return $response;
}

?>
